From 32423032c3f25b810f0a3c80fe184f3a357cd8a0 Mon Sep 17 00:00:00 2001
From: Julien Rouhaud <julien.rouhaud@free.fr>
Date: Sat, 4 Jun 2022 01:50:14 +0800
Subject: [PATCH v2 1/4] WIP: Rename attnum to attphysnum

This is the bare minimum to make the code compile, a lot more effort is
required for a proper patch.

A lot of things would need to be renamed accordingly, for instance
attnameAttNum() and similar, and a lot of variables name attnums, pk_attnums
and so on.

Author: Julien Rouhaud
Reviewed-by: FIXME
Discussion: FIXME
---
 contrib/amcheck/amcheck--1.2--1.3.sql         |   2 +-
 contrib/amcheck/expected/check_heap.out       |  92 ++---
 contrib/amcheck/verify_heapam.c               |  30 +-
 contrib/amcheck/verify_nbtree.c               |   2 +-
 contrib/dblink/dblink.c                       |  14 +-
 contrib/file_fdw/file_fdw.c                   |  22 +-
 contrib/lo/lo.c                               |  14 +-
 contrib/pageinspect/expected/brin.out         |   8 +-
 contrib/pageinspect/pageinspect--1.2--1.3.sql |   2 +-
 contrib/pageinspect/pageinspect--1.5.sql      |   2 +-
 contrib/pageinspect/pageinspect--1.8--1.9.sql |   2 +-
 contrib/pageinspect/sql/brin.sql              |   2 +-
 contrib/postgres_fdw/deparse.c                |  22 +-
 contrib/postgres_fdw/postgres_fdw.c           |  38 +-
 contrib/sepgsql/dml.c                         |  10 +-
 contrib/sepgsql/label.c                       |   2 +-
 contrib/sepgsql/relation.c                    |  32 +-
 contrib/sepgsql/sepgsql.h                     |   8 +-
 contrib/spi/autoinc.c                         |  10 +-
 contrib/spi/insert_username.c                 |  10 +-
 contrib/spi/moddatetime.c                     |  10 +-
 contrib/test_decoding/test_decoding.c         |   2 +-
 contrib/vacuumlo/vacuumlo.c                   |   2 +-
 doc/src/sgml/amcheck.sgml                     |   4 +-
 doc/src/sgml/fdwhandler.sgml                  |   2 +-
 doc/src/sgml/pageinspect.sgml                 |   4 +-
 doc/src/sgml/ref/psql-ref.sgml                |   2 +-
 doc/src/sgml/sources.sgml                     |   2 +-
 doc/src/sgml/trigger.sgml                     |   2 +-
 doc/src/sgml/xaggr.sgml                       |   4 +-
 src/backend/access/brin/brin_tuple.c          |  18 +-
 src/backend/access/common/attmap.c            |   2 +-
 src/backend/access/common/heaptuple.c         | 108 +++---
 src/backend/access/common/indextuple.c        |  36 +-
 src/backend/access/common/printsimple.c       |   2 +-
 src/backend/access/common/tupdesc.c           |  30 +-
 src/backend/access/gin/ginbulk.c              |  24 +-
 src/backend/access/gin/ginentrypage.c         |  30 +-
 src/backend/access/gin/ginfast.c              |  18 +-
 src/backend/access/gin/ginget.c               |  42 +--
 src/backend/access/gin/gininsert.c            |  46 +--
 src/backend/access/gin/ginlogic.c             |  10 +-
 src/backend/access/gin/ginscan.c              |  22 +-
 src/backend/access/gin/ginutil.c              |  16 +-
 src/backend/access/gin/ginvacuum.c            |   6 +-
 src/backend/access/index/genam.c              |   8 +-
 src/backend/access/index/indexam.c            |  20 +-
 src/backend/access/nbtree/nbtutils.c          |  14 +-
 src/backend/bootstrap/bootstrap.c             |  78 ++--
 src/backend/catalog/aclchk.c                  |  70 ++--
 src/backend/catalog/catalog.c                 |   2 +-
 src/backend/catalog/genbki.pl                 |  20 +-
 src/backend/catalog/heap.c                    |  76 ++--
 src/backend/catalog/index.c                   |  18 +-
 src/backend/catalog/indexing.c                |   6 +-
 src/backend/catalog/information_schema.sql    |  68 ++--
 src/backend/catalog/objectaddress.c           |  24 +-
 src/backend/catalog/pg_attrdef.c              |  32 +-
 src/backend/catalog/pg_depend.c               |  12 +-
 src/backend/catalog/pg_publication.c          |  14 +-
 src/backend/catalog/system_views.sql          |  18 +-
 src/backend/commands/analyze.c                |  28 +-
 src/backend/commands/copy.c                   |  12 +-
 src/backend/commands/copyfrom.c               |  42 +--
 src/backend/commands/copyfromparse.c          |  12 +-
 src/backend/commands/copyto.c                 |  46 +--
 src/backend/commands/createas.c               |   6 +-
 src/backend/commands/event_trigger.c          |  14 +-
 src/backend/commands/indexcmds.c              |   2 +-
 src/backend/commands/matview.c                |  12 +-
 src/backend/commands/publicationcmds.c        |  22 +-
 src/backend/commands/sequence.c               |  10 +-
 src/backend/commands/statscmds.c              |   8 +-
 src/backend/commands/tablecmds.c              | 342 +++++++++---------
 src/backend/commands/trigger.c                |  10 +-
 src/backend/commands/tsearchcmds.c            |  16 +-
 src/backend/commands/typecmds.c               |  16 +-
 src/backend/executor/execExpr.c               |  52 +--
 src/backend/executor/execExprInterp.c         | 110 +++---
 src/backend/executor/execMain.c               |   4 +-
 src/backend/executor/execPartition.c          |   6 +-
 src/backend/executor/execTuples.c             |  52 +--
 src/backend/executor/execUtils.c              |   2 +-
 src/backend/executor/nodeAgg.c                |  12 +-
 src/backend/executor/spi.c                    |  14 +-
 src/backend/foreign/foreign.c                 |  10 +-
 src/backend/jit/llvm/llvmjit_deform.c         | 104 +++---
 src/backend/jit/llvm/llvmjit_expr.c           |   4 +-
 src/backend/optimizer/util/appendinfo.c       |   2 +-
 src/backend/parser/analyze.c                  |   6 +-
 src/backend/parser/parse_clause.c             |  16 +-
 src/backend/parser/parse_relation.c           | 122 +++----
 src/backend/parser/parse_target.c             |  52 +--
 src/backend/parser/parse_type.c               |   8 +-
 src/backend/parser/parse_utilcmd.c            |  64 ++--
 src/backend/replication/basebackup_copy.c     |   6 +-
 src/backend/replication/logical/proto.c       |  14 +-
 src/backend/replication/logical/relation.c    |  20 +-
 .../replication/logical/reorderbuffer.c       |   2 +-
 src/backend/replication/logical/tablesync.c   |  14 +-
 src/backend/replication/logical/worker.c      |  20 +-
 src/backend/replication/pgoutput/pgoutput.c   |   2 +-
 src/backend/replication/walsender.c           |   4 +-
 src/backend/statistics/dependencies.c         | 116 +++---
 src/backend/statistics/extended_stats.c       |  40 +-
 src/backend/statistics/mvdistinct.c           |   4 +-
 src/backend/utils/adt/acl.c                   |  34 +-
 src/backend/utils/adt/expandedrecord.c        |   4 +-
 src/backend/utils/adt/misc.c                  |   6 +-
 src/backend/utils/adt/ri_triggers.c           |   6 +-
 src/backend/utils/adt/ruleutils.c             |  90 ++---
 src/backend/utils/adt/selfuncs.c              |  60 +--
 src/backend/utils/cache/attoptcache.c         |  16 +-
 src/backend/utils/cache/catcache.c            |  10 +-
 src/backend/utils/cache/lsyscache.c           |  58 +--
 src/backend/utils/cache/relcache.c            |  42 +--
 src/backend/utils/cache/syscache.c            |  18 +-
 src/bin/initdb/initdb.c                       |   2 +-
 src/bin/pg_amcheck/pg_amcheck.c               |   4 +-
 src/bin/pg_amcheck/t/003_check.pl             |   2 +-
 src/bin/pg_dump/pg_dump.c                     |  26 +-
 src/bin/psql/describe.c                       | 158 ++++++--
 src/bin/psql/tab-complete.c                   |   4 +-
 src/include/access/genam.h                    |   6 +-
 src/include/access/gin_private.h              |  24 +-
 src/include/access/htup_details.h             |  36 +-
 src/include/access/itup.h                     |  18 +-
 src/include/bootstrap/bootstrap.h             |   2 +-
 src/include/catalog/dependency.h              |   2 +-
 src/include/catalog/heap.h                    |   8 +-
 src/include/catalog/pg_attrdef.h              |  10 +-
 src/include/catalog/pg_attribute.h            |   8 +-
 src/include/catalog/pg_constraint.h           |   4 +-
 src/include/catalog/pg_index.h                |   2 +-
 src/include/catalog/pg_partitioned_table.h    |   2 +-
 src/include/catalog/pg_statistic.h            |   2 +-
 src/include/catalog/pg_statistic_ext.h        |   2 +-
 src/include/catalog/pg_trigger.h              |   2 +-
 src/include/executor/execExpr.h               |   6 +-
 src/include/executor/spi.h                    |   2 +-
 src/include/executor/tuptable.h               |  42 +--
 src/include/foreign/foreign.h                 |   2 +-
 src/include/parser/parsetree.h                |   4 +-
 src/include/utils/acl.h                       |   8 +-
 src/include/utils/attoptcache.h               |   2 +-
 src/include/utils/lsyscache.h                 |  18 +-
 src/include/utils/relcache.h                  |   2 +-
 src/include/utils/selfuncs.h                  |   2 +-
 src/include/utils/syscache.h                  |   6 +-
 src/pl/plpgsql/src/plpgsql.h                  |   2 +-
 ...summarization-and-inprogress-insertion.out |  28 +-
 .../test_misc/t/001_constraint_validation.pl  |   2 +-
 src/test/regress/expected/alter_table.out     |  32 +-
 src/test/regress/expected/create_index.out    |  14 +-
 src/test/regress/expected/create_table.out    |   4 +-
 src/test/regress/expected/create_type.out     |   2 +-
 src/test/regress/expected/foreign_key.out     |   2 +-
 src/test/regress/expected/indexing.out        |  48 +--
 src/test/regress/expected/inherit.out         |   2 +-
 src/test/regress/expected/insert.out          |  14 +-
 src/test/regress/expected/join.out            |   4 +-
 src/test/regress/expected/oidjoins.out        |  16 +-
 src/test/regress/expected/opr_sanity.out      |   4 +-
 src/test/regress/expected/psql.out            |   4 +-
 src/test/regress/expected/rules.out           |  18 +-
 src/test/regress/expected/sanity_check.out    |   6 +-
 src/test/regress/expected/type_sanity.out     |  10 +-
 src/test/regress/regress.c                    |  30 +-
 src/test/regress/sql/alter_table.sql          |  22 +-
 src/test/regress/sql/create_index.sql         |   4 +-
 src/test/regress/sql/create_table.sql         |   4 +-
 src/test/regress/sql/create_type.sql          |   2 +-
 src/test/regress/sql/foreign_key.sql          |   2 +-
 src/test/regress/sql/indexing.sql             |  12 +-
 src/test/regress/sql/inherit.sql              |   2 +-
 src/test/regress/sql/insert.sql               |   4 +-
 src/test/regress/sql/join.sql                 |   4 +-
 src/test/regress/sql/opr_sanity.sql           |   4 +-
 src/test/regress/sql/psql.sql                 |   4 +-
 src/test/regress/sql/sanity_check.sql         |   6 +-
 src/test/regress/sql/type_sanity.sql          |  10 +-
 src/tutorial/syscat.source                    |   4 +-
 182 files changed, 1959 insertions(+), 1857 deletions(-)

diff --git a/contrib/amcheck/amcheck--1.2--1.3.sql b/contrib/amcheck/amcheck--1.2--1.3.sql
index 7237ab738c..5c49ddde17 100644
--- a/contrib/amcheck/amcheck--1.2--1.3.sql
+++ b/contrib/amcheck/amcheck--1.2--1.3.sql
@@ -14,7 +14,7 @@ CREATE FUNCTION verify_heapam(relation regclass,
 							  endblock bigint default null,
 							  blkno OUT bigint,
 							  offnum OUT integer,
-							  attnum OUT integer,
+							  attphysnum OUT integer,
 							  msg OUT text)
 RETURNS SETOF record
 AS 'MODULE_PATHNAME', 'verify_heapam'
diff --git a/contrib/amcheck/verify_heapam.c b/contrib/amcheck/verify_heapam.c
index e488f5e234..89d69ab394 100644
--- a/contrib/amcheck/verify_heapam.c
+++ b/contrib/amcheck/verify_heapam.c
@@ -71,7 +71,7 @@ typedef struct ToastedAttribute
 	struct varatt_external toast_pointer;
 	BlockNumber blkno;			/* block in main table */
 	OffsetNumber offnum;		/* offset in main table */
-	AttrNumber	attnum;			/* attribute in main table */
+	AttrNumber	attphysnum;			/* attribute in main table */
 } ToastedAttribute;
 
 /*
@@ -130,7 +130,7 @@ typedef struct HeapCheckContext
 
 	/* Values for iterating over attributes within the tuple */
 	uint32		offset;			/* offset in tuple data */
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 
 	/* True if tuple's xmax makes it eligible for pruning */
 	bool		tuple_could_be_pruned;
@@ -272,10 +272,10 @@ verify_heapam(PG_FUNCTION_ARGS)
 
 	/*
 	 * If we report corruption when not examining some individual attribute,
-	 * we need attnum to be reported as NULL.  Set that up before any
+	 * we need attphysnum to be reported as NULL.  Set that up before any
 	 * corruption reporting might happen.
 	 */
-	ctx.attnum = -1;
+	ctx.attphysnum = -1;
 
 	/* Construct the tuplestore and tuple descriptor */
 	SetSingleFuncCall(fcinfo, 0);
@@ -552,7 +552,7 @@ verify_heapam(PG_FUNCTION_ARGS)
 static void
 report_corruption_internal(Tuplestorestate *tupstore, TupleDesc tupdesc,
 						   BlockNumber blkno, OffsetNumber offnum,
-						   AttrNumber attnum, char *msg)
+						   AttrNumber attphysnum, char *msg)
 {
 	Datum		values[HEAPCHECK_RELATION_COLS];
 	bool		nulls[HEAPCHECK_RELATION_COLS];
@@ -562,8 +562,8 @@ report_corruption_internal(Tuplestorestate *tupstore, TupleDesc tupdesc,
 	MemSet(nulls, 0, sizeof(nulls));
 	values[0] = Int64GetDatum(blkno);
 	values[1] = Int32GetDatum(offnum);
-	values[2] = Int32GetDatum(attnum);
-	nulls[2] = (attnum < 0);
+	values[2] = Int32GetDatum(attphysnum);
+	nulls[2] = (attphysnum < 0);
 	values[3] = CStringGetTextDatum(msg);
 
 	/*
@@ -591,7 +591,7 @@ static void
 report_corruption(HeapCheckContext *ctx, char *msg)
 {
 	report_corruption_internal(ctx->tupstore, ctx->tupdesc, ctx->blkno,
-							   ctx->offnum, ctx->attnum, msg);
+							   ctx->offnum, ctx->attphysnum, msg);
 	ctx->is_corrupt = true;
 }
 
@@ -608,7 +608,7 @@ report_toast_corruption(HeapCheckContext *ctx, ToastedAttribute *ta,
 						char *msg)
 {
 	report_corruption_internal(ctx->tupstore, ctx->tupdesc, ta->blkno,
-							   ta->offnum, ta->attnum, msg);
+							   ta->offnum, ta->attphysnum, msg);
 	ctx->is_corrupt = true;
 }
 
@@ -1272,7 +1272,7 @@ check_tuple_attribute(HeapCheckContext *ctx)
 	struct varatt_external toast_pointer;
 
 	infomask = ctx->tuphdr->t_infomask;
-	thisatt = TupleDescAttr(RelationGetDescr(ctx->rel), ctx->attnum);
+	thisatt = TupleDescAttr(RelationGetDescr(ctx->rel), ctx->attphysnum);
 
 	tp = (char *) ctx->tuphdr + ctx->tuphdr->t_hoff;
 
@@ -1287,7 +1287,7 @@ check_tuple_attribute(HeapCheckContext *ctx)
 	}
 
 	/* Skip null values */
-	if (infomask & HEAP_HASNULL && att_isnull(ctx->attnum, ctx->tuphdr->t_bits))
+	if (infomask & HEAP_HASNULL && att_isnull(ctx->attphysnum, ctx->tuphdr->t_bits))
 		return true;
 
 	/* Skip non-varlena values, but update offset first */
@@ -1448,7 +1448,7 @@ check_tuple_attribute(HeapCheckContext *ctx)
 		VARATT_EXTERNAL_GET_POINTER(ta->toast_pointer, attr);
 		ta->blkno = ctx->blkno;
 		ta->offnum = ctx->offnum;
-		ta->attnum = ctx->attnum;
+		ta->attphysnum = ctx->attphysnum;
 		ctx->toasted_attributes = lappend(ctx->toasted_attributes, ta);
 	}
 
@@ -1560,12 +1560,12 @@ check_tuple(HeapCheckContext *ctx)
 	 * attributes collected from the page.
 	 */
 	ctx->offset = 0;
-	for (ctx->attnum = 0; ctx->attnum < ctx->natts; ctx->attnum++)
+	for (ctx->attphysnum = 0; ctx->attphysnum < ctx->natts; ctx->attphysnum++)
 		if (!check_tuple_attribute(ctx))
 			break;				/* cannot continue */
 
-	/* revert attnum to -1 until we again examine individual attributes */
-	ctx->attnum = -1;
+	/* revert attphysnum to -1 until we again examine individual attributes */
+	ctx->attphysnum = -1;
 }
 
 /*
diff --git a/contrib/amcheck/verify_nbtree.c b/contrib/amcheck/verify_nbtree.c
index 2beeebb163..f1d935a538 100644
--- a/contrib/amcheck/verify_nbtree.c
+++ b/contrib/amcheck/verify_nbtree.c
@@ -2575,7 +2575,7 @@ bt_normalize_tuple(BtreeCheckState *state, IndexTuple itup)
 
 		/* Assume untoasted/already normalized datum initially */
 		toast_free[i] = false;
-		normalized[i] = index_getattr(itup, att->attnum,
+		normalized[i] = index_getattr(itup, att->attphysnum,
 									  tupleDescriptor,
 									  &isnull[i]);
 		if (att->attbyval || att->attlen != -1 || isnull[i])
diff --git a/contrib/dblink/dblink.c b/contrib/dblink/dblink.c
index a561d1d652..306d5ec054 100644
--- a/contrib/dblink/dblink.c
+++ b/contrib/dblink/dblink.c
@@ -1694,7 +1694,7 @@ dblink_build_sql_insert(PG_FUNCTION_ARGS)
 	src_pkattvals = get_text_array_contents(src_pkattvals_arry, &src_nitems);
 
 	/*
-	 * There should be one source array key value for each key attnum
+	 * There should be one source array key value for each key attphysnum
 	 */
 	if (src_nitems != pknumatts)
 		ereport(ERROR,
@@ -1708,7 +1708,7 @@ dblink_build_sql_insert(PG_FUNCTION_ARGS)
 	tgt_pkattvals = get_text_array_contents(tgt_pkattvals_arry, &tgt_nitems);
 
 	/*
-	 * There should be one target array key value for each key attnum
+	 * There should be one target array key value for each key attphysnum
 	 */
 	if (tgt_nitems != pknumatts)
 		ereport(ERROR,
@@ -1780,7 +1780,7 @@ dblink_build_sql_delete(PG_FUNCTION_ARGS)
 	tgt_pkattvals = get_text_array_contents(tgt_pkattvals_arry, &tgt_nitems);
 
 	/*
-	 * There should be one target array key value for each key attnum
+	 * There should be one target array key value for each key attphysnum
 	 */
 	if (tgt_nitems != pknumatts)
 		ereport(ERROR,
@@ -1859,7 +1859,7 @@ dblink_build_sql_update(PG_FUNCTION_ARGS)
 	src_pkattvals = get_text_array_contents(src_pkattvals_arry, &src_nitems);
 
 	/*
-	 * There should be one source array key value for each key attnum
+	 * There should be one source array key value for each key attphysnum
 	 */
 	if (src_nitems != pknumatts)
 		ereport(ERROR,
@@ -1873,7 +1873,7 @@ dblink_build_sql_update(PG_FUNCTION_ARGS)
 	tgt_pkattvals = get_text_array_contents(tgt_pkattvals_arry, &tgt_nitems);
 
 	/*
-	 * There should be one target array key value for each key attnum
+	 * There should be one target array key value for each key attphysnum
 	 */
 	if (tgt_nitems != pknumatts)
 		ereport(ERROR,
@@ -2902,7 +2902,7 @@ escape_param_str(const char *str)
  *
  * The user supplies an int2vector of 1-based logical attnums, plus a count
  * argument (the need for the separate count argument is historical, but we
- * still check it).  We check that each attnum corresponds to a valid,
+ * still check it).  We check that each attphysnum corresponds to a valid,
  * non-dropped attribute of the rel.  We do *not* prevent attnums from being
  * listed twice, though the actual use-case for such things is dubious.
  * Note that before Postgres 9.0, the user's attnums were interpreted as
@@ -2923,7 +2923,7 @@ validate_pkattnums(Relation rel,
 	/* Don't take more array elements than there are */
 	pknumatts_arg = Min(pknumatts_arg, pkattnums_arg->dim1);
 
-	/* Must have at least one pk attnum selected */
+	/* Must have at least one pk attphysnum selected */
 	if (pknumatts_arg <= 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
diff --git a/contrib/file_fdw/file_fdw.c b/contrib/file_fdw/file_fdw.c
index 4773cadec0..7980f67a14 100644
--- a/contrib/file_fdw/file_fdw.c
+++ b/contrib/file_fdw/file_fdw.c
@@ -430,7 +430,7 @@ get_file_fdw_attribute_options(Oid relid)
 	Relation	rel;
 	TupleDesc	tupleDesc;
 	AttrNumber	natts;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	List	   *fnncolumns = NIL;
 	List	   *fncolumns = NIL;
 
@@ -441,9 +441,9 @@ get_file_fdw_attribute_options(Oid relid)
 	natts = tupleDesc->natts;
 
 	/* Retrieve FDW options for all user-defined attributes. */
-	for (attnum = 1; attnum <= natts; attnum++)
+	for (attphysnum = 1; attphysnum <= natts; attphysnum++)
 	{
-		Form_pg_attribute attr = TupleDescAttr(tupleDesc, attnum - 1);
+		Form_pg_attribute attr = TupleDescAttr(tupleDesc, attphysnum - 1);
 		List	   *options;
 		ListCell   *lc;
 
@@ -451,7 +451,7 @@ get_file_fdw_attribute_options(Oid relid)
 		if (attr->attisdropped)
 			continue;
 
-		options = GetForeignColumnOptions(relid, attnum);
+		options = GetForeignColumnOptions(relid, attphysnum);
 		foreach(lc, options)
 		{
 			DefElem    *def = (DefElem *) lfirst(lc);
@@ -852,7 +852,7 @@ check_selective_binary_conversion(RelOptInfo *baserel,
 	ListCell   *lc;
 	Relation	rel;
 	TupleDesc	tupleDesc;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 	Bitmapset  *attrs_used = NULL;
 	bool		has_wholerow = false;
 	int			numattrs;
@@ -895,25 +895,25 @@ check_selective_binary_conversion(RelOptInfo *baserel,
 	rel = table_open(foreigntableid, AccessShareLock);
 	tupleDesc = RelationGetDescr(rel);
 
-	while ((attnum = bms_first_member(attrs_used)) >= 0)
+	while ((attphysnum = bms_first_member(attrs_used)) >= 0)
 	{
 		/* Adjust for system attributes. */
-		attnum += FirstLowInvalidHeapAttributeNumber;
+		attphysnum += FirstLowInvalidHeapAttributeNumber;
 
-		if (attnum == 0)
+		if (attphysnum == 0)
 		{
 			has_wholerow = true;
 			break;
 		}
 
 		/* Ignore system attributes. */
-		if (attnum < 0)
+		if (attphysnum < 0)
 			continue;
 
 		/* Get user attributes. */
-		if (attnum > 0)
+		if (attphysnum > 0)
 		{
-			Form_pg_attribute attr = TupleDescAttr(tupleDesc, attnum - 1);
+			Form_pg_attribute attr = TupleDescAttr(tupleDesc, attphysnum - 1);
 			char	   *attname = NameStr(attr->attname);
 
 			/* Skip dropped attributes (probably shouldn't see any here). */
diff --git a/contrib/lo/lo.c b/contrib/lo/lo.c
index 457be26c4e..367e2fb866 100644
--- a/contrib/lo/lo.c
+++ b/contrib/lo/lo.c
@@ -24,7 +24,7 @@ Datum
 lo_manage(PG_FUNCTION_ARGS)
 {
 	TriggerData *trigdata = (TriggerData *) fcinfo->context;
-	int			attnum;			/* attribute number to monitor	*/
+	int			attphysnum;			/* attribute number to monitor	*/
 	char	  **args;			/* Args containing attr name	*/
 	TupleDesc	tupdesc;		/* Tuple Descriptor				*/
 	HeapTuple	rettuple;		/* Tuple to be returned			*/
@@ -61,9 +61,9 @@ lo_manage(PG_FUNCTION_ARGS)
 	isdelete = TRIGGER_FIRED_BY_DELETE(trigdata->tg_event);
 
 	/* Get the column we're interested in */
-	attnum = SPI_fnumber(tupdesc, args[0]);
+	attphysnum = SPI_fnumber(tupdesc, args[0]);
 
-	if (attnum <= 0)
+	if (attphysnum <= 0)
 		elog(ERROR, "%s: column \"%s\" does not exist",
 			 trigdata->tg_trigger->tgname, args[0]);
 
@@ -74,10 +74,10 @@ lo_manage(PG_FUNCTION_ARGS)
 	 * object associated with the original value is unlinked.
 	 */
 	if (newtuple != NULL &&
-		bms_is_member(attnum - FirstLowInvalidHeapAttributeNumber, trigdata->tg_updatedcols))
+		bms_is_member(attphysnum - FirstLowInvalidHeapAttributeNumber, trigdata->tg_updatedcols))
 	{
-		char	   *orig = SPI_getvalue(trigtuple, tupdesc, attnum);
-		char	   *newv = SPI_getvalue(newtuple, tupdesc, attnum);
+		char	   *orig = SPI_getvalue(trigtuple, tupdesc, attphysnum);
+		char	   *newv = SPI_getvalue(newtuple, tupdesc, attphysnum);
 
 		if (orig != NULL && (newv == NULL || strcmp(orig, newv) != 0))
 			DirectFunctionCall1(be_lo_unlink,
@@ -96,7 +96,7 @@ lo_manage(PG_FUNCTION_ARGS)
 	 */
 	if (isdelete)
 	{
-		char	   *orig = SPI_getvalue(trigtuple, tupdesc, attnum);
+		char	   *orig = SPI_getvalue(trigtuple, tupdesc, attphysnum);
 
 		if (orig != NULL)
 		{
diff --git a/contrib/pageinspect/pageinspect--1.2--1.3.sql b/contrib/pageinspect/pageinspect--1.2--1.3.sql
index 9c55a6e598..9d3af061b6 100644
--- a/contrib/pageinspect/pageinspect--1.2--1.3.sql
+++ b/contrib/pageinspect/pageinspect--1.2--1.3.sql
@@ -34,7 +34,7 @@ LANGUAGE C STRICT;
 CREATE FUNCTION brin_page_items(IN page bytea, IN index_oid regclass,
 	OUT itemoffset int,
 	OUT blknum int,
-	OUT attnum int,
+	OUT attphysnum int,
 	OUT allnulls bool,
 	OUT hasnulls bool,
 	OUT placeholder bool,
diff --git a/contrib/pageinspect/pageinspect--1.5.sql b/contrib/pageinspect/pageinspect--1.5.sql
index 1e40c3c97e..1e759b504d 100644
--- a/contrib/pageinspect/pageinspect--1.5.sql
+++ b/contrib/pageinspect/pageinspect--1.5.sql
@@ -219,7 +219,7 @@ LANGUAGE C STRICT PARALLEL SAFE;
 CREATE FUNCTION brin_page_items(IN page bytea, IN index_oid regclass,
 	OUT itemoffset int,
 	OUT blknum int,
-	OUT attnum int,
+	OUT attphysnum int,
 	OUT allnulls bool,
 	OUT hasnulls bool,
 	OUT placeholder bool,
diff --git a/contrib/pageinspect/pageinspect--1.8--1.9.sql b/contrib/pageinspect/pageinspect--1.8--1.9.sql
index be89a64ca1..389d981f82 100644
--- a/contrib/pageinspect/pageinspect--1.8--1.9.sql
+++ b/contrib/pageinspect/pageinspect--1.8--1.9.sql
@@ -127,7 +127,7 @@ DROP FUNCTION brin_page_items(IN page bytea, IN index_oid regclass);
 CREATE FUNCTION brin_page_items(IN page bytea, IN index_oid regclass,
     OUT itemoffset int,
     OUT blknum int8,
-    OUT attnum int,
+    OUT attphysnum int,
     OUT allnulls bool,
     OUT hasnulls bool,
     OUT placeholder bool,
diff --git a/contrib/pageinspect/sql/brin.sql b/contrib/pageinspect/sql/brin.sql
index 45098c1ef5..555e83f98a 100644
--- a/contrib/pageinspect/sql/brin.sql
+++ b/contrib/pageinspect/sql/brin.sql
@@ -13,7 +13,7 @@ SELECT * FROM brin_revmap_data(get_raw_page('test1_a_idx', 0)) LIMIT 5;
 SELECT * FROM brin_revmap_data(get_raw_page('test1_a_idx', 1)) LIMIT 5;
 
 SELECT * FROM brin_page_items(get_raw_page('test1_a_idx', 2), 'test1_a_idx')
-    ORDER BY blknum, attnum LIMIT 5;
+    ORDER BY blknum, attphysnum LIMIT 5;
 
 -- Failure for non-BRIN index.
 CREATE INDEX test1_a_btree ON test1 (a);
diff --git a/contrib/postgres_fdw/deparse.c b/contrib/postgres_fdw/deparse.c
index 8f4d8a5022..5cd519511e 100644
--- a/contrib/postgres_fdw/deparse.c
+++ b/contrib/postgres_fdw/deparse.c
@@ -1890,13 +1890,13 @@ deparseInsertSql(StringInfo buf, RangeTblEntry *rte,
 		first = true;
 		foreach(lc, targetAttrs)
 		{
-			int			attnum = lfirst_int(lc);
+			int			attphysnum = lfirst_int(lc);
 
 			if (!first)
 				appendStringInfoString(buf, ", ");
 			first = false;
 
-			deparseColumnRef(buf, rtindex, attnum, rte, false);
+			deparseColumnRef(buf, rtindex, attphysnum, rte, false);
 		}
 
 		appendStringInfoString(buf, ") VALUES (");
@@ -1905,8 +1905,8 @@ deparseInsertSql(StringInfo buf, RangeTblEntry *rte,
 		first = true;
 		foreach(lc, targetAttrs)
 		{
-			int			attnum = lfirst_int(lc);
-			Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+			int			attphysnum = lfirst_int(lc);
+			Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
 			if (!first)
 				appendStringInfoString(buf, ", ");
@@ -1971,8 +1971,8 @@ rebuildInsertSql(StringInfo buf, Relation rel,
 		first = true;
 		foreach(lc, target_attrs)
 		{
-			int			attnum = lfirst_int(lc);
-			Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+			int			attphysnum = lfirst_int(lc);
+			Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
 			if (!first)
 				appendStringInfoString(buf, ", ");
@@ -2021,14 +2021,14 @@ deparseUpdateSql(StringInfo buf, RangeTblEntry *rte,
 	first = true;
 	foreach(lc, targetAttrs)
 	{
-		int			attnum = lfirst_int(lc);
-		Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+		int			attphysnum = lfirst_int(lc);
+		Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
 		if (!first)
 			appendStringInfoString(buf, ", ");
 		first = false;
 
-		deparseColumnRef(buf, rtindex, attnum, rte, false);
+		deparseColumnRef(buf, rtindex, attphysnum, rte, false);
 		if (attr->attgenerated)
 			appendStringInfoString(buf, " = DEFAULT");
 		else
@@ -2099,7 +2099,7 @@ deparseDirectUpdateSql(StringInfo buf, PlannerInfo *root,
 	forboth(lc, targetlist, lc2, targetAttrs)
 	{
 		TargetEntry *tle = lfirst_node(TargetEntry, lc);
-		int			attnum = lfirst_int(lc2);
+		int			attphysnum = lfirst_int(lc2);
 
 		/* update's new-value expressions shouldn't be resjunk */
 		Assert(!tle->resjunk);
@@ -2108,7 +2108,7 @@ deparseDirectUpdateSql(StringInfo buf, PlannerInfo *root,
 			appendStringInfoString(buf, ", ");
 		first = false;
 
-		deparseColumnRef(buf, rtindex, attnum, rte, false);
+		deparseColumnRef(buf, rtindex, attphysnum, rte, false);
 		appendStringInfoString(buf, " = ");
 		deparseExpr((Expr *) tle->expr, &context);
 	}
